<template>
  <perfect-scrollbar>
    <v-card title="Filtrar Materias" class="ma-2 pa-2">
      <v-divider />
      <v-form class="ma-2">
        <v-checkbox v-model="filterDias" label="Filtrar por Día" />
        <template v-if="filterDias" v-for="[numero, dia] in diasPosibles">
          <v-checkbox v-model="dias" :label="dia" :value="numero" />
        </template>
        <v-divider />
        <v-checkbox v-model="filterTurnos" label="Filtrar por Turno" />
        <template v-if="filterTurnos" v-for="[numero, turno] in turnosPosibles">
          <v-checkbox v-model="turnos" :label="turno" :value="numero" />
        </template>
        <v-divider />
        <v-checkbox v-model="filterProfesor" label="Filtrar por Profesor" />
        <template v-if="filterProfesor" class="flex-box">
          <v-btn icon="mdi-plus" @click="profesores.push('')" class="ma-2" />
          <template v-for="(profesor, index) in profesores">
            <v-text-field v-model="profesores[index]" label="Profesor">
              <template v-slot:append>
                <v-btn icon="mdi-minus" @click="profesores.splice(index, 1)" />
              </template>
            </v-text-field>
          </template>
        </template>
        <v-divider />
        <v-btn
          icon="mdi-filter-check-outline"
          @click="getMaterias()"
          class="ma-2"
        />
        <v-divider class="ma-2" />
        <template v-for="materia in materias" class="ma-2">
          <v-card
            :title="materia.descripcion"
            :subtitle="materia.username_profesor"
          >
            <v-card-text>
              {{ diasPosibles.get(materia.dia_clase) }}, turno
              {{ turnosPosibles.get(materia.turno) }}
            </v-card-text>
          </v-card>
        </template>
      </v-form>
    </v-card>

    <v-card title="Emitir Mensaje" class="ma-2 pa-2">
      <v-divider />
      <v-form class="ma-2">
        <v-text-field v-model="titulo" label="Titulo" :rules="tituloRules" />
        <v-text-field
          v-model="contenido"
          label="Contenido"
          :rules="contenidoRules"
        />
        <v-select
          v-model="prioridad"
          label="Prioridad"
          :items="['normal', 'alta', 'emergencia']"
        />
        <v-btn icon="mdi-multicast" @click="send()" />
      </v-form>
    </v-card>
  </perfect-scrollbar>
</template>

<script setup lang="ts">
import { Ref, ref } from "vue";
import { backendCollector } from "../../../data/collectors/backendCollector";
import { ChatRoom } from "../../../data/models/ChatRoom";
import { MateriaDict } from "../../../data/models/Materia";

const titulo = ref("");
const tituloRules = ref([
  (value: string) => {
    if (value?.length > 3) return true;
    return "El titulo debe contener mas de 3 caracteres";
  },
]);

const contenido = ref("");
const contenidoRules = ref([
  (value: string) => {
    if (value?.length > 255) {
      return "El contenido puede ser hasta 255 caracteres";
    }
    return true;
  },
]);

const prioridad: Ref<"normal" | "alta" | "emergencia"> = ref("normal");

const filterDias = ref(false);
const diasPosibles = ref(
  new Map([
    [1, "Lunes"],
    [2, "Martes"],
    [3, "Miércoles"],
    [4, "Jueves"],
    [5, "Viernes"],
    [6, "Sábado"],
  ])
);
const dias: Ref<number[]> = ref([]);
const filterTurnos = ref(false);
const turnosPosibles = ref(
  new Map([
    [1, "Mañana"],
    [2, "Tarde"],
    [3, "Noche"],
  ])
);
const turnos: Ref<number[]> = ref([]);
const filterProfesor = ref(false);
const profesores: Ref<string[]> = ref([]);

const materias: Ref<MateriaDict[] | undefined> = ref(undefined);
async function getMaterias() {
  const materiaIds = await backendCollector.server.getMateriasRange(
    filterDias.value ? dias.value : [],
    filterTurnos.value ? turnos.value : [],
    filterProfesor.value ? profesores.value : []
  );
  if (!materiaIds.success) {
    alert(
      materiaIds.code != 500
        ? materiaIds.error
        : "Error en el servidor al enviar mensajes"
    );
    return;
  }
  materias.value = materiaIds.data ?? undefined;
}

function formInvalido() {
  if (
    tituloRules.value[0](titulo.value) != true ||
    contenidoRules.value[0](contenido.value) != true ||
    materias.value == undefined
  ) {
    return true;
  }
  return false;
}
async function send() {
  if (formInvalido()) {
    alert("Form invalido");
    return;
  }
  const ids = materias.value!.map((value) => value.uid);
  const mensaje: ChatRoom["mensajes"][number] = {
    emisor: backendCollector.server.username!,
    titulo: titulo.value,
    timestamp: new Date().toISOString(),
    contenido: contenido.value,
    prioridad: prioridad.value,
  };
  const enviado = await backendCollector.server.multicastMensaje(ids!, mensaje);
  if (!enviado.success) {
    alert(enviado.code == 500 ? "error al enviar mensaje" : enviado.error);
  } else {
    alert("mensaje enviado");
    window.location.reload();
  }
}
</script>

<style>
html {
  overflow: visible !important;
  scrollbar-width: none;
}
</style>
